Package org.optaplanner.core.impl.score.director.easy

## Class EasyScoreDirector<Solution_>

- java.lang.Object
- - org.optaplanner.core.impl.score.director.AbstractScoreDirector<Solution_,​EasyScoreDirectorFactory<Solution_>>
  - - org.optaplanner.core.impl.score.director.easy.EasyScoreDirector<Solution_>

- Type Parameters:
    `Solution_` - the solution type, the class with the `PlanningSolution` annotation
  All Implemented Interfaces:
    `AutoCloseable`, `Cloneable`, `InnerScoreDirector<Solution_>`, `ScoreDirector<Solution_>`

      public class EasyScoreDirector<Solution_>
      extends AbstractScoreDirector<Solution_,​EasyScoreDirectorFactory<Solution_>>

  Easy java implementation of `ScoreDirector`, which recalculates the `Score` of the `working solution` every time. This is non-incremental calculation, which is slow. This score director implementation does not support `ScoreDirector.getConstraintMatchTotals()`, `ScoreDirector.getConstraintMatchTotalMap()` and `ScoreDirector.getIndictmentMap()`.
  See Also:
    `ScoreDirector`

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.score.director.AbstractScoreDirector

      `allChangesWillBeUndoneBeforeStepEnds, calculationCount, constraintMatchEnabledPreference, logger, lookUpEnabled, lookUpManager, scoreDirectorFactory, variableListenerSupport, workingEntityListRevision, workingInitScore, workingSolution`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `EasyScoreDirector​(EasyScoreDirectorFactory<Solution_> scoreDirectorFactory, boolean lookUpEnabled, boolean constraintMatchEnabledPreference, EasyScoreCalculator<Solution_,​?> easyScoreCalculator)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Score` | `calculateScore()` | Calculates the `Score` and updates the `working solution` accordingly.
    `Map<String,​ConstraintMatchTotal>` | `getConstraintMatchTotalMap()` | `ConstraintMatch`s are not supported by this `ScoreDirector` implementation.
    `Collection<ConstraintMatchTotal>` | `getConstraintMatchTotals()` | `ConstraintMatch`s are not supported by this `ScoreDirector` implementation.
    `EasyScoreCalculator<Solution_,​?>` | `getEasyScoreCalculator()` |
    `Map<Object,​Indictment>` | `getIndictmentMap()` | `ConstraintMatch`s are not supported by this `ScoreDirector` implementation.
    `boolean` | `isConstraintMatchEnabled()` | Always false, `ConstraintMatchTotal`s are not supported by this `ScoreDirector` implementation.

    - ### Methods inherited from class org.optaplanner.core.impl.score.director.AbstractScoreDirector

      `afterEntityAdded, afterEntityAdded, afterEntityRemoved, afterEntityRemoved, afterProblemFactAdded, afterProblemFactRemoved, afterProblemPropertyChanged, afterVariableChanged, afterVariableChanged, assertExpectedUndoMoveScore, assertExpectedWorkingScore, assertPredictedScoreFromScratch, assertShadowVariablesAreNotStale, assertWorkingScoreFromScratch, beforeEntityAdded, beforeEntityAdded, beforeEntityRemoved, beforeEntityRemoved, beforeProblemFactAdded, beforeProblemFactRemoved, beforeProblemPropertyChanged, beforeVariableChanged, beforeVariableChanged, buildScoreCorruptionAnalysis, buildShadowVariableAnalysis, changeVariableFacade, clone, cloneSolution, cloneWorkingSolution, close, createChildThreadScoreDirector, createShadowVariablesViolationMessage, doAndProcessMove, doAndProcessMove, explainScore, getCalculationCount, getScoreDefinition, getScoreDirectorFactory, getSolutionDescriptor, getSupplyManager, getWorkingEntityCount, getWorkingEntityList, getWorkingEntityListRevision, getWorkingSolution, getWorkingValueCount, isAllChangesWillBeUndoneBeforeStepEnds, isConstraintMatchEnabledPreference, isLookUpEnabled, isWorkingEntityListDirty, lookUpWorkingObject, lookUpWorkingObjectOrReturnNull, overwriteConstraintMatchEnabledPreference, resetCalculationCount, setAllChangesWillBeUndoneBeforeStepEnds, setCalculatedScore, setWorkingEntityListDirty, setWorkingSolution, toString, triggerVariableListeners`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.impl.score.director.ScoreDirector

      `dispose`

- - ### Constructor Detail

    - #### EasyScoreDirector

          public EasyScoreDirector​(EasyScoreDirectorFactory<Solution_> scoreDirectorFactory,
                                   boolean lookUpEnabled,
                                   boolean constraintMatchEnabledPreference,
                                   EasyScoreCalculator<Solution_,​?> easyScoreCalculator)

  - ### Method Detail

    - #### getEasyScoreCalculator

          public EasyScoreCalculator<Solution_,​?> getEasyScoreCalculator()

    - #### calculateScore

          public Score calculateScore()

      Description copied from interface: `ScoreDirector`
      Calculates the `Score` and updates the `working solution` accordingly.
      Returns:
        never null, the `Score` of the `working solution`

    - #### isConstraintMatchEnabled

          public boolean isConstraintMatchEnabled()

      Always false, `ConstraintMatchTotal`s are not supported by this `ScoreDirector` implementation.
      Returns:
        false

    - #### getConstraintMatchTotals

          public Collection<ConstraintMatchTotal> getConstraintMatchTotals()

      `ConstraintMatch`s are not supported by this `ScoreDirector` implementation.
      Returns:
        throws `IllegalStateException`
      Throws:
        `IllegalStateException` - always
      See Also:
        `ScoreDirector.getConstraintMatchTotalMap()`, `ScoreDirector.getIndictmentMap()`

    - #### getConstraintMatchTotalMap

          public Map<String,​ConstraintMatchTotal> getConstraintMatchTotalMap()

      `ConstraintMatch`s are not supported by this `ScoreDirector` implementation.
      Returns:
        throws `IllegalStateException`
      Throws:
        `IllegalStateException` - always
      See Also:
        `ScoreDirector.getIndictmentMap()`

    - #### getIndictmentMap

          public Map<Object,​Indictment> getIndictmentMap()

      `ConstraintMatch`s are not supported by this `ScoreDirector` implementation.
      Returns:
        throws `IllegalStateException`
      Throws:
        `IllegalStateException` - always
      See Also:
        `ScoreDirector.getConstraintMatchTotalMap()`